SELECT
    p.ID
    , p.[Date]
    , p.[Sum]
    , a.Name AS AccountName
    , c.Name AS CompanyName
    , i.Name AS ItemName
    , p.Comment
FROM
    Payment p
    LEFT OUTER JOIN Item i ON i.ID = p.ItemID
    LEFT OUTER JOIN Company c ON c.ID = p.CompanyID
    LEFT OUTER JOIN Account a ON a.ID = p.AccountID
WHERE
    COALESCE(a.Name, '') = COALESCE(@AccountName, a.Name, '')
    AND COALESCE(c.Name, '') = COALESCE(@CompanyName, c.Name, '')
    AND COALESCE(i.Name, '') = COALESCE(@ItemName, i.Name, '')
