﻿
-- Selects source contacts with the specified ContactID
SELECT
    s.Source
    , s.SourceID
    , s.MergeDate
    , s.IsJunk
    , d.ContactID
    , s.SourceFirstName
    , s.SourceLastName
    , s.SourceEmail
    , s.SourceSecondaryEmail
    , s.SourceMobile
    , s.SourcePhone
    , s.SourceCompany
    , s.SourceJobTitle
    , s.SourceHeadline
    , s.SourceIndustry
    , s.SourceLocationName
    , s.SourceCountryCode
    , s.SourceProfileUrl    
FROM
    SourceContacts s
    INNER JOIN SourceContactID d ON d.[Source] = s.[Source] AND d.SourceID = s.SourceID
WHERE
    d.ContactID = @ID
UNION ALL
-- Selects source contacts with en empty ContactID if ContactID is NULL
SELECT
    s.Source
    , s.SourceID
    , s.MergeDate
    , s.IsJunk
    , d.ContactID
    , s.SourceFirstName
    , s.SourceLastName
    , s.SourceEmail
    , s.SourceSecondaryEmail
    , s.SourceMobile
    , s.SourcePhone
    , s.SourceCompany
    , s.SourceJobTitle
    , s.SourceHeadline
    , s.SourceIndustry
    , s.SourceLocationName
    , s.SourceCountryCode
    , s.SourceProfileUrl    
FROM
    SourceContacts s
    LEFT OUTER JOIN SourceContactID d ON d.[Source] = s.[Source] AND d.SourceID = s.SourceID
WHERE
    d.ContactID IS NULL
    AND @ID IS NULL
UNION ALL
-- Selects source contacts with the LastName as contact's LastName and an empty ContactID
SELECT
    s.Source
    , s.SourceID
    , s.MergeDate
    , s.IsJunk
    , d.ContactID
    , s.SourceFirstName
    , s.SourceLastName
    , s.SourceEmail
    , s.SourceSecondaryEmail
    , s.SourceMobile
    , s.SourcePhone
    , s.SourceCompany
    , s.SourceJobTitle
    , s.SourceHeadline
    , s.SourceIndustry
    , s.SourceLocationName
    , s.SourceCountryCode
    , s.SourceProfileUrl    
FROM
    SourceContacts s
    LEFT OUTER JOIN SourceContactID d ON d.[Source] = s.[Source] AND d.SourceID = s.SourceID
    INNER JOIN ContactNames n ON n.LastName = s.SourceLastName
WHERE
    d.ContactID IS NULL
    AND n.ID = @ID