﻿SELECT
    c.*
    , COALESCE(l.ContactCount, 0) + COALESCE(r.ContactCount, 0) AS ContactCount
    , CASE WHEN c.Checked IS NULL THEN 1 ELSE NULL END AS HasErrors
FROM
    Countries c
    LEFT OUTER JOIN (
        SELECT
            r.Country
            , COUNT(*) AS ContactCount
        FROM
            Contacts c
            INNER JOIN ContactCountry r ON r.ID = c.ID
        GROUP BY
            r.Country
    ) l ON l.Country = c.CountryName
    LEFT OUTER JOIN (
        SELECT
            s.SourceCountryCode AS CountryCode
            , COUNT(*) AS ContactCount
        FROM
            SourceContacts s
            INNER JOIN SourceContactID d ON d.[Source] = s.[Source] AND d.SourceID = s.SourceID
            LEFT OUTER JOIN ContactCountry r ON r.ID = d.ContactID
        WHERE
            d.ContactID IS NOT NULL
            AND r.ID IS NULL
        GROUP BY
            s.SourceCountryCode
    ) r ON r.CountryCode = c.CountryCode