﻿SELECT
    w.*
    , s.SourceDomainContactCount
    , c.DomainContactCount
    , t.WebsiteContactCount
    , CASE WHEN w.Checked IS NULL THEN 1 ELSE NULL END AS HasErrors
FROM
    Websites w

    LEFT OUTER JOIN (
        SELECT
            LOWER(SUBSTRING(c.SourceEmail, CHARINDEX('@', c.SourceEmail) + 1, 255)) AS Domain
            , COUNT(*) AS SourceDomainContactCount
        FROM
            SourceContacts c
        GROUP BY
            LOWER(SUBSTRING(c.SourceEmail, CHARINDEX('@', c.SourceEmail) + 1, 255))
    ) s ON s.Domain = w.Domain

    LEFT OUTER JOIN (
        SELECT
            LOWER(SUBSTRING(e.Email, CHARINDEX('@', e.Email) + 1, 255)) AS Domain
            , COUNT(*) AS DomainContactCount
        FROM
            Contacts c
            INNER JOIN ContactEmail e ON e.ID = c.ID
        GROUP BY
            LOWER(SUBSTRING(e.Email, CHARINDEX('@', e.Email) + 1, 255))
    ) c ON c.Domain = w.Domain

    LEFT OUTER JOIN (
        SELECT
            w.Website
            , COUNT(*) AS WebsiteContactCount
        FROM
            Contacts c
            INNER JOIN ContactWebsite w ON w.ID = c.ID
        GROUP BY
            w.Website
    ) t ON t.Website = w.Website